generic rec curry = case
| ($a * $b -> $c) -> $d -> $e =>
    (* the input type is tuple
       but the return type is a function and not still curried *)
    fun f -> curry (fun x y -> f (x,y))
| ($a -> $b) -> $a -> $c => 
    (* the input type is done, 
       but the return type is a function and not still curried *)
    fun f x -> curry (f x)
| ($a -> $b) -> $a -> $b => 
    (* the input and return types are already curried *)
    fun f -> f
;;
